//GRAFO-ESERCIZIO
/* grafo G con n nodi rappresentato tramite matrice di adiacenza,
dato un nodo u e un insieme di nodi I, verifichi per ogni nodo i
diverso da u che il percorso da u a i non contenga elementi di I */

/* matrice di adiacenza
    |	0	1	2	3	4
----|-----------------------------------------
  0 |	0	1	0	0	1
  1 |	0	0	1	0	0
  2 |	0	0	0	1	0
  3 |	1	0	0	0	0
  4 |	0	0	0	0	0
----|-----------------------------------------
*/

#define n 5;

struct matrice{
	int VISITATO[n];
	int MAT[n][n];
	int BLACKLIST[n];
};

typedef struct matrice *grafo;
typedef int nodo;

void DFS(grafo G, nodo u, insieme I, int flag);

void DFS(grafo G, nodo u, insieme I, int flag)
{
	if(flag==1)
		BLACKLIST[u]=1;

	G->VISITATO[u]=1;

	if(APPARTIENE(u, I))
		flag=1;

	for(j=0; j<n; j++)
	{
		if((G->MAT[u][j] !=0) && (G->VISITATO[j]!=1))
		{
			DFS(G, j, I, flag);
		}
	}
}

//INSIEMI-BY-LISTE-ORDINATE-MY.H
#include "lista.h"

typedef lista insieme;

insieme CREAINSIEME {
  return CREALISTA();
}
void INSERISCI(insieme A, posizione P, tipoelem E){

	INSLISTA(E,&P);
}

void INTERSEZIONE ( insieme A, insieme B, insieme C ) {
  posizione p, q, r;
  
  C = CREAINSIEME();
  p = PRIMOLISTA(A);
  q = PRIMOLISTA(B);
  r = PRIMOLISTA(C);
  
  while ( !FINELISTA(p, A) && !FINELISTA(q, B) )
  
    if ( LEGGILISTA(p, A) == LEGGILISTA(q, B) ) {
	
	INSLISTA ( LEGGILISTA(p, A), &r );
      	p = SUCCLISTA(p);
      	q = SUCCLISTA(q);
    } 

    else {
      	 if ( LEGGILISTA(p, A) < LEGGILISTA(q, B) )
         p = SUCCLISTA(p);

	 else 
         q = SUCCLISTA(q);
    }
}

void UNIONE(insieme A, insieme B, insieme C){
	posizione p,q,r;

	C=CREAINSIEME();
	p=PRIMOLISTA(A);
	q=PRIMOLISTA(B);
	r=PRIMOLISTA(C);

	while ( !FINELISTA(p,A) || !FINELISTA(q,B)){
		if(FINELISTA(A)){
			while(!FINELISTA(q,B)){
				INSLISTA(LEGGILISTA(q,B), &r);
				q=SUCCLISTA(q);
			}
		}
		else if(FINELISTA(B)){
			while(!FINELISTA(p,A)){
				INSLISTA(LEGGILISTA(p,A), &r);
				q=SUCCLISTA(q);
			}
		}
		else{
			if (LEGGILISTA(p,A) == LEGGILISTA(q,B)){
				INSLISTA(LEGGILISTA(p,A), &r);
				p=SUCCLISTA(p);
				q=SUCCLISTA(q);
			}
			else if (LEGGILISTA(p,A) < LEGGILISTA(q,B)){
				INSLISTA(LEGGILISTA(p,A), &r);
				p=SUCCLISTA(p);
			}
			else{
				INSLISTA(LEGGILISTA(p,A), &r);
				q=SUCCLISTA(q);
			}
		}
	}
}

void DIFFERENZA ( insieme A, insieme B, insieme C ) {
  posizione p, q, r;
  
  C = CREAINSIEME();
  p = PRIMOLISTA(A);
  q = PRIMOLISTA(B);
  r = PRIMOLISTA(C);
  
  while ( !FINELISTA(p, A) && !FINELISTA(q, B) )
  
    if ( LEGGILISTA(p, A) == LEGGILISTA(q, B) ) {
	
	p = SUCCLISTA(p);
      	q = SUCCLISTA(q);
    } 

    else {
      	 if ( LEGGILISTA(p, A) < LEGGILISTA(q, B) )
         INSLISTA ( LEGGILISTA(p, A), &r );
	 p = SUCCLISTA(p);

	 else 
         q = SUCCLISTA(q);
    }
}

void DIFFERENZASIMMETRICA(insieme A, insieme B, insieme C) {
	
	C = CREAINSIEME();
	D = CREAINSIEME();
	E = CREAINSIEME();

	UNIONE(A,B,D);
	INTERSEZIONE(A,B,E);
	DIFFERENZA(D,E,C);
}

void DIFFERENZASIMMETRICA2(insieme A, insieme B, insieme C) {
	
	posizione p,q,r;

	C=CREAINSIEME();
	p=PRIMOLISTA(A);
	q=PRIMOLISTA(B);
	r=PRIMOLISTA(C);

	while ( !FINELISTA(p,A) || !FINELISTA(q,B)){

    if ( LEGGILISTA(p, A) == LEGGILISTA(q, B) ) {
	p = SUCCLISTA(p);
      	q = SUCCLISTA(q);
    } 

    else {
      	 if ( LEGGILISTA(p, A) < LEGGILISTA(q, B) )
         INSLISTA ( LEGGILISTA(p, A), &r );
	 p = SUCCLISTA(p);

	 else
	 INSLISTA ( LEGGILISTA(q, B), &r );
        q = SUCCLISTA(q);
    }

}

/* prototipi, commenti
nell'intersezione e nella differenza 2 viene fuori del casino immenso
quando una delle 2 liste finisce. il puntatore posizione potrebbe ricominciare da capo
(ma forse non fa nenache del casino). l'altro problema  continuare a scrivere nell'insieme C
quello che rimane dentro alla lista rimasta
mettere || invece che && nella diffsimm2 e mettere sotto un'altro while che prende l'insieme che
non abbiamo ancora finito di scorrere e lo scorriamo infilando nell'isieme C.

//SCHEDULING_TOPOGRAFIC
/* data una relazione di precedenza tra programmi, rappresentabile
con un grafo, realizzato a sua volta con una matrice di adiacenza,
questo programma mette nel vettore ORDINALE[] l'ordina di esecuzione
dei programmi */

/* matrice di adiacenza
    |	0	1	2	3	4	5	6	7
----|--------------------------------------------------------------
  0 |	0	1	0	0	0	0	0	0
  1 |	0	0	1	0	0	0	0	0
  2 |	0	0	0	0	0	0	0	0
  3 |	0	0	0	0	1	0	0	0
  4 |	0	0	0	0	0	0	0	0
  5 |	0	0	0	0	0	0	1	0
  6 |	0	0	0	0	0	0	0	1
  7 |	0	0	1	0	0	0	0	0
----|--------------------------------------------------------------
*/

#include <stdio.h>
#define n 8

struct matrice{
	int MAT[n][n];
	int VISITATO[n];
	int ORDINALE[n];
	int START[n];
};

typedef struct matrice *grafo;
typedef int nodo;

int TEMPI[n] = { 2, 2, 3, 1, 1, 1, 5, 3};	//vettore tempi di esecuzione
int k = 1;					//contatore globale per topologicalsort()

//PROTOTIPI
void TOPOLOGICALSORT(grafo G);
void SCHEDULING(grafo G);
void DFS(grafo G, nodo u);

int main()
{
	/* inizializziamo la matrice grafo e ci mettiamo le adiacenze */
	grafo G = (grafo)malloc(sizeof(struct matrice));

	int i, j;
	for(i=0; i<n; i++)
		for(j=0; j<n; j++);
			G->MAT[i][j]=0;

	G->MAT[0][1]=1;
	G->MAT[1][2]=1;
	G->MAT[3][4]=1;
	G->MAT[5][6]=1;
	G->MAT[6][7]=1;
	G->MAT[7][2]=1;

	/* inizializziamo gli altri vettori */

	for(i=0; i<n; i++) G->ORDINALE[i]=0;
	for(i=0; i<n; i++) G->START[i]=0;
	for(i=0; i<n; i++) G->VISITATO[i]=0;

	SCHEDULING(G);
	
	/*stampiamo la matrice*/
	puts("MATRICE DELLE ADIACENZE CHE RAPPRESENTA IL GRAFO:");
	for(i=0; i<n; i++)
	{
		for(j=0; j<n; j++)
			printf(" %d ", G->MAT[i][j]);
	
		printf("\n");
	}
	
	/*stampiamo vettore ordinale*/
	puts("VETTORE ORDINALE:");
	for(i=0; i<n; i++)
	{
		printf(" %d ",G->ORDINALE[i]);
	}
	printf("\n");

	/*stampiamo vettore start*/
	puts("VETTORE START:");
	for(i=0; i<n; i++)
	{
		printf(" %d ",G->START[i]);
	}
	printf("\n");
	
	/*stampiamo vettore visitato*/
	puts("VETTORE VISITATO:");
	for(i=0; i<n; i++)
	{
		printf(" %d ",G->VISITATO[i]);
	}
	printf("\n");

	return 0;
}

void SCHEDULING(grafo G)
{
	TOPOLOGICALSORT(G);
	G->START[G->ORDINALE[0]]= 0;
	
	int i;
	nodo t, tm1;

	for(i=1; i<n; i++)
	{
		t = G->ORDINALE[i];	
		tm1 = G->ORDINALE[i-1];
		G->START[t] = G->START[tm1] + TEMPI[tm1];
	}
}

void TOPOLOGICALSORT(grafo G)
{
	int i;			//contatore
	
	for(i=0; i<n; i++)
	{
		if (!G->VISITATO[i]) DFS(G,i);
	}
}
	
void DFS(grafo G, nodo i)
{
	int j;		//contatori

	G->VISITATO[i]=1;

	for(j=0; j<n; j++)
	{
		if((G->MAT[i][j] !=0) && (G->VISITATO[j]!=1))
		{
			DFS(G, j);
		}
	}
	
	G->ORDINALE[n-k] = i;
	k++;
}
