#include<stdlib.h>
#include<stdio.h>
/* Implementazione di alberi binari tramite 
   puntatore padre/primofiglio/fratello     */

typedef int tipoelem;
 
typedef struct nodostruct * binalbero;

typedef struct nodostruct * nodo;

struct nodostruct {
  tipoelem valore;
  nodo     padre;
  nodo     sinistro;
  nodo     destro;
};


//PROTOTIPI
binalbero CREABINALBERO();
int BINALBEROVUOTO(binalbero T);
nodo BINRADICE(binalbero T);
nodo BINPADRE(nodo n);
nodo FIGLIOSINISTRO( nodo n );
nodo FIGLIODESTRO(nodo n);
int SINISTROVUOTO(nodo n);
int DESTROVUOTO(nodo n);
void CONSTRBINALBERO(binalbero * T, binalbero U);
tipoelem LEGGINODO(nodo n);
void SCRIVINODO(tipoelem v, nodo n);
void CANCSOTTOBINALBERO(nodo n, binalbero * T);
void INITBINALBERORAND(int h, binalbero *T);
void STAMPALBEROBIN(nodo U, binalbero T);
void AGGIUNGINODO(nodo U, binalbero T, int somma);
int int_rand(int,int);

// CREABINALBERO: ritorna un puntatore inizializzato a NULL
binalbero CREABINALBERO() {
  binalbero T = NULL;
  return T;
}


// verifica se un albero e' vuoto
int BINALBEROVUOTO(binalbero T) {
  return ( T == NULL ) ? 1 : 0;
}


// restituisce il riferimento alla radice
nodo BINRADICE ( binalbero T ) {
  return T;
}


// restituisce il riferimento al padre
nodo BINPADRE ( nodo n ) {
  return n->padre;
}


// restituisce il riferimento al figlio sinistro
nodo FIGLIOSINISTRO ( nodo n ) {
  return n->sinistro;
}


// restituisce il riferimento al figlio destro
nodo FIGLIODESTRO ( nodo n ) {
  return n->destro;
}


// verifica se il figlio sinistro esiste
int SINISTROVUOTO ( nodo n ) {
  return ( n->sinistro == NULL ) ? 1 : 0;
}


// verifica se il figlio destro esiste
int DESTROVUOTO ( nodo n ) {
  return ( n->destro == NULL ) ? 1 : 0;
}


/* 
/ CONSTRBINALBERO: costruisce un albero binario a partire da due 
/                  alberi binari T ed U. 
/                  L'albero binario T e' passato per variabile 
/                  poiche' T viene aggiornato con il riferimento 
/       U           alla radice del nuovo albero
*/
void CONSTRBINALBERO ( binalbero * T, binalbero U ) {
  nodo u;
  
  u           = (nodo) malloc ( sizeof(struct nodostruct) );
  u->sinistro = *T;
  u->destro   = U;
  u->padre    = NULL;
  
  if ( *T != NULL )
    (*T)->padre = u;
  
  if ( U != NULL ) 
    U->padre = u;
  
  *T = u;
}


// legge il campo valore di un nodo
tipoelem LEGGINODO ( nodo n ) {
  return n->valore;
}


// scrive il campo valore di un nodo
void SCRIVINODO ( tipoelem v, nodo n ) {
  n->valore = v;
}
 

/* CANCSOTTOBINALBERO: cancella un sottoalbero binario 
                       radicato nel nodo u
*/
void CANCSOTTOBINALBERO ( nodo n, binalbero * T ) {
  
  if ( ! SINISTROVUOTO(n) ) {
    CANCSOTTOBINALBERO ( FIGLIOSINISTRO(n), T );
    n->sinistro = NULL;
  }
  
  if ( ! DESTROVUOTO(n) ) {
    CANCSOTTOBINALBERO ( FIGLIODESTRO(n), T );
    n->destro  = NULL;
  }
  
  if ( n == *T ) {    
    // nodo radice
    *T = NULL;
    printf("free nodo radice valore: %d\n", LEGGINODO(n));   
  } else  {    
   if ( BINPADRE(n)->sinistro == n ) 
      BINPADRE(n)->sinistro = NULL;
    
    if ( BINPADRE(n)->destro == n ) 
      BINPADRE(n)->destro = NULL; 
     
    printf("free nodo valoUre: %d\n", LEGGINODO(n));
  }
  
  free(n);  
}

//crea un albero binario di altezza h, assegnando ad ogni nodo un valore random
void INITBINALBERORAND(int h, binalbero *T){

	binalbero U = CREABINALBERO();
    srand(15612);                    //accendo il generatore di num casuali
	if(h==0){
		CONSTRBINALBERO(T,NULL);
		(*T)->valore=int_rand(1,1050);
	}
	else{
		INITBINALBERORAND(h-1, T);
		INITBINALBERORAND(h-1,&U);
		CONSTRBINALBERO(T,U);
		(*T)->valore=int_rand(15,2050);
	}
}

void STAMPALBEROBIN(nodo U, binalbero T){
	printf("\n\n%d\n", U->valore);
	/*if(U->padre!=NULL)printf("padre: %d\n", U->padre->valore);
	if(U->sinistro!=NULL)printf("sx: %d\n", U->sinistro->valore);
	if(U->destro!=NULL)printf("dx: %d\n", U->destro->valore);*/

	if((!SINISTROVUOTO(U)) && (!DESTROVUOTO(U))){
		STAMPALBEROBIN(FIGLIOSINISTRO(U),T);
		STAMPALBEROBIN(FIGLIODESTRO(U),T);
		} 
}

void AGGIUNGINODO(nodo U, binalbero T, int somma){
		
	if(!SINISTROVUOTO(U)){

	nodo temp=FIGLIOSINISTRO(U);
	
	do{
		AGGIUNGINODO(temp,T,somma+LEGGINODO(U));
		temp=temp->destro;
		}while(!temp->destro);
	}
	
	else{
	nodo nuovo=NULL;
	CONSTRBINALBERO(&nuovo,NULL);
	U->sinistro=nuovo;
	nuovo->padre=U;
	SCRIVINODO(somma,nuovo);
	}
}

int int_rand(int min,int max)
{int numero_casuale;
 int differenza;
 differenza = (max - min) + 1;
 numero_casuale = rand() % differenza ;
 numero_casuale = numero_casuale + min ;
 return numero_casuale;
}
