#define N 4
#define M 10

#include "coda-by-lista.h"

struct structgrafo {
  int NODI[N+1];     
  int ARCHI[M];    
  int VISITATO[N]; 
  int INCODA[N];   
};

typedef struct structgrafo * grafo;
typedef int nodo;

/***********************************************************************/
grafo CREAGRAFO () {
  return (grafo) malloc(sizeof(struct structgrafo));
}

/***********************************************************************/
// Funzioni ausiliarie

void visita_arco(nodo u, nodo v) {
  printf("Visita Arco (%d,%d)\n", u, v);
}

/***********************************************************************/

void DFS ( grafo G, nodo u ) {
  int i;\
  nodo v;
  
  G->VISITATO[u] = 1; // marca u visitato
  
  for ( i = G->NODI[u]; i < G->NODI[u+1]; i++ ) {
  
    v = G->ARCHI[i];
    
    visita_arco(u, v); // visita l'arco
    
    if ( ! G->VISITATO[v] ) 
      DFS(G, v);
  }
}  
  
/***********************************************************************/

void BFS ( grafo G, nodo u ) {
  nodo v;   
  coda Q;
  int i;
  
  Q = CREACODA();  
  INCODA(u, Q);
  G->INCODA[u] = 1;
  
  while ( ! CODAVUOTA(Q) ) {
    u = LEGGICODA(Q);
    FUORICODA(Q);
    G->INCODA[u] = 0;
        
    G->VISITATO[u] = 1; // marca u visitato
    
    for ( i = G->NODI[u]; i < G->NODI[u+1]; i++ ) {
      
      v = G->ARCHI[i];
      
      visita_arco(u, v); // visita l'arco      
      
      if (( ! G->VISITATO[v] ) && ( ! G->INCODA[u] )) {
      	INCODA(v, Q);	
      	G->INCODA[v] = 1;
      }
      
    }
    
  }
}

