/* implementazione di una pila di integer tramite vettore 
   circolare */

#define MAXLUNG 10

typedef int tipoelem;

struct structpila {
  int      testa;
  int      fine;
  tipoelem elementi[MAXLUNG];
};

typedef struct structpila * pila;

pila CREAPILA () {
  pila P;
  P = (pila) malloc(sizeof(struct structpila));  
  P->testa = -1;
  P->fine  = -1;
  return P;
}

int PILAVUOTA ( pila P ) {
  return (P->testa == -1) ? 1 : 0;
}

tipoelem LEGGIPILA ( pila P ) {
  tipoelem elemento;
  if ( ! PILAVUOTA ( P ) ) {
    elemento = P->elementi[P->testa];
  } else {
    fprintf(stderr, "ERROR pila vuota !\n");
    elemento = -1;
  }
  return elemento;
}

void FUORIPILA ( pila P ) { // pop
  if ( ! PILAVUOTA ( P ) ) {
    P->testa = P->testa -1;
    if ( P->testa == -1 ) {
      P->fine = P->testa;
    }
  }
}

void INPILA ( tipoelem a, pila P ) { // push
  int tmp;
  tmp = (P->testa + 1) % MAXLUNG;
  if ( tmp == P->fine ) {
    fprintf(stderr, "ERROR pila piena !\n");
  } else {
    P->testa = tmp;
    P->elementi[P->testa] = a;
    if ( P->fine == -1 ) {
      P->fine = 0;
    }
  }
}

void DISTRUGGIPILA ( pila P ) {
  if ( ! PILAVUOTA(P) ) {
    fprintf(stderr, "WARNING: destroing a non void pila\n");  
  }
  free(P);
}
