/* Implementazione di una pila tramite vettore di MAXLUNG elementi */

#define MAXLUNG 10

typedef int tipoelem;

struct structpila {
  int      testa;
  tipoelem elementi[MAXLUNG];
};

typedef struct structpila * pila;

/* alloca una pila e restituisce il puntatore ad essa */
pila CREAPILA ( ) {
  pila P;
  P = (pila) malloc(sizeof(struct structpila));
  P->testa = -1;
  return P; /* return pointer to a "pila" */
}


/* return 1 se la pila e' vuota 0 altrimenti */ 
int PILAVUOTA ( pila P ) {
  return (P->testa == -1) ? 1 : 0;
}


/* return 1 se la pila e' piena 0 altrimenti */ 
int PILAPIENA ( pila P ) {
  return (P->testa == MAXLUNG-1) ? 1 : 0;
}

/* legge l'elemento in testa alla pila */
tipoelem LEGGIPILA ( pila P ) {
  tipoelem elemento;
  if ( ! PILAVUOTA ( P ) ) {
    elemento = P->elementi[P->testa];
  } else {
    fprintf(stderr, "ERROR pila vuota !\n");
    elemento = -1;
  }  
  return elemento;
}


/* estrae un elemento dalla pila */
void FUORIPILA ( pila P ) { // pop
  if ( ! PILAVUOTA ( P ) ) {
    P->testa = P->testa - 1;
  }
}


/* inserisce un elemento nella pila */
void INPILA ( tipoelem a, pila P ) { // push
  if ( P->testa == MAXLUNG ) {
    fprintf(stderr, "ERROR pila satura !\n");
  } else {
    P->testa = P->testa + 1;
    P->elementi[P->testa] = a;
  }
}


/* dealloca la memoria allocata per una pila */
void DISTRUGGIPILA ( pila P ) {
  if ( ! PILAVUOTA(P) ) {
    fprintf(stderr, "WARNING: destroing a non void pila\n");  
  }
  free(P);
}
  
