// except: Program demonstrating exception handling.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 1 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>

float ReadIntArray(int *p, int n)
{  float sum = 0;
   cout << "Enter " << n << " integers:\n";
   for (int i=0; i<n; i++)
   {  cin >> p[i];
      if (cin.fail()) throw i;
      sum += p[i];
   }
   return sum/n;
}

int main()
{  float avg;
   int a[10], b[12];
   cout << "See what happens if, somewhere in the input,\n"
           "you type some incorrect character.\n";
   try
   {  avg = ReadIntArray(a, 10);
      cout << "10 integers read. Average: " << avg << endl;
      avg = ReadIntArray(b, 12);
      cout << "12 integers read. Average: " << avg << endl;
   }
   catch (int k)
   {  cout <<  "Only " << k << " integers read "
         "due to incorrect input.\n";
   }
   cout << "End of program.\n";
   return 0;
}

