// ints.h: Dynamic arrays based on reference counting.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 1 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
class ints {
public:
   ints()
   {  pRep = new intsrep;
      pRep->p = NULL; pRep->length = pRep->refcount = 1;
   }
   ints(int *a, int n);  // Defined in ints.cpp
   ints(const ints &r)
   {  r.pRep->refcount++;
      pRep = r.pRep;
   }
   ~ints()
   {  if (--pRep->refcount == 0)
      {  delete[] pRep->p;
         delete pRep;
      }
   }
   ints &operator=(const ints &r)
   {  r.pRep->refcount++;
      if (--pRep->refcount == 0)
      {  delete[] pRep->p;
         delete pRep;
      }
      pRep = r.pRep;
      return *this;
   }
   int len()const {return pRep->length;}
private:
   struct intsrep{int *p, length, refcount;} *pRep;
};

