// roman1: From decimal to Roman.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 1 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include <stdlib.h>

class Roman {
private:
   enum {L=100};
public:
   Roman(unsigned n);
   char a[L];
};

Roman::Roman(unsigned n)
{  int v[] = {1000, 900, 500, 400, 100, 90, 50,
       40, 10, 9, 5, 4, 1}, len = sizeof(v)/sizeof(*v);
   char *r[] = {"M", "CM", "D", "CD", "C", "XC", "L",
       "XL", "X", "IX", "V", "IV", "I"};
   int pos = 0;
   for (int i=0; i<len; i++)
   {  while (v[i] <= n)
      {  if (pos + 3 > L)
         {  cout << " Number too large.\n"; exit(1);
         }
         a[pos++] = r[i][0];
         if (r[i][1]) a[pos++] = r[i][1];
         n -= v[i];
      }
   }
   a[pos] = '\0';
}

int main()
{  unsigned n;
   cout << "Enter a decimal number: ";
   cin >> n;
   cout << "Roman: " << Roman(n).a << endl;
   return 0;
}

