// bmmdemo2: Producing the index of a book, using
//    balanced multiway merging for external sorting.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 3 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include <iomanip.h>
#include <string.h>
#include "bmmsort.h"

class rec {
public:
   char IndexEntry[13];
   int PageNr;
};
int operator>=(const rec &x, const rec &y)
{  return strcmp(x.IndexEntry, y.IndexEntry) >= 0;
}
int operator>(const rec &x, const rec &y)
{  return strcmp(x.IndexEntry, y.IndexEntry) > 0;
}
int operator<=(const rec &x, const rec &y)
{  return strcmp(x.IndexEntry, y.IndexEntry) <= 0;
}
int operator<(const rec &x, const rec &y)
{  return strcmp(x.IndexEntry, y.IndexEntry) < 0;
}
ostream &operator<<(ostream &os, const rec &x)
{  return os << setiosflags(ios::left) << setw(12)
      << x.IndexEntry << resetiosflags(ios::left)
      << setw(3) << x.PageNr;
}
istream &operator>>(istream &is, rec &x)
{  return is >> setw(12) >> x.IndexEntry >> x.PageNr;
}
int main()
{  char InpFileName[50], OutFileName[50];
   rec dummy;
   cout << "Name of input file:  ";
   cin >> setw(50) >> InpFileName;
   cout << "Name of output file: ";
   cin >> setw(50) >> OutFileName;
   // Third argument indicates item type:
   if (BMMSort(InpFileName, OutFileName, dummy))
      cout << "File problem\n";
   return 0;
}

