template <class T>
void merge(const T *a, int na, const T *b, int nb, T *c)
{  int ia=0, ib=0, ic=0;
   while (ia < na && ib < nb)
      c[ic++] = (a[ia] < b[ib] ? a[ia++] : b[ib++]);
   while (ia < na) c[ic++] = a[ia++];
   while (ib < nb) c[ic++] = b[ib++];
}

We can use this function as the basis of a simple and fast sorting algorithm, which has one drawback, however: it does not sort in place but requires additional memory space as large as the array to be sorted:
template <class T>
void MergeSort(T *a, int n)
{  if (n < 2) return;
   int nLeft = n/2, nRight = n - nLeft;
   MergeSort(a, nLeft); MergeSort(a + nLeft, nRight);
   T *p = new T[n];
   merge(a, nLeft, a + nLeft, nRight, p);
   for (int i=0; i<n; i++) a[i] = p[i];
   delete[] p;
}

