// qs1: Compare speed of two quicksort implementations
//      (to be linked with qsorta.cpp).

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 3 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include <stdlib.h>
#include <time.h>
#include "qsorta.h"

int cmp1(const void *p, const void *q)
{  return *(double *)p < *(double *)q ? -1 :
      (*(double *)p > *(double *)q);
}

int main()
{  double *b, *c;
   int n, ntimes, limit, i, k;
   clock_t t1, t2;
   cout << "Enter n, ntimes, limit: ";
   cin >> n >> ntimes >> limit;
   b = new double[n];
   c = new double[n];
   if (!b || !c) exit(1);
   srand(1);
   for (i=0; i<100; i++) rand();
   t1 = clock();
   for (k=0; k<ntimes; k++)
   {  for (i=0; i<n; i++) b[i] = double(rand() % limit);
      qsort(b, n, sizeof(double), cmp1);
   }
   t2 = clock();
   cout << "qsort: " << double(t2 - t1)/CLK_TCK << endl;
   for (i=0; i<n; i++) c[i] = b[i];
   srand(1);
   for (i=0; i<100; i++) rand();
   t1 = clock();
   for (k=0; k<ntimes; k++)
   {  for (i=0; i<n; i++) b[i] = double(rand() % limit);
      qsorta(b, n, sizeof(double), cmp1);
   }
   t2 = clock();
   cout << "qsorta: " << double(t2 - t1)/CLK_TCK << endl;
   for (i=0; i<n; i++) if (b[i] != c[i])
   {  cout << "Sort wrong!\n"; break;
   }
   return 0;
}

