// quicksrt.h: A quicksort template.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 3 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

template <class T>
inline void swap(T &x, T &y)
{  T w = x; x = y; y = w;
}

template <class T>
inline void swap3(T &x, T &y, T &z)
{  T w = x; x = y; y = z; z = w;
}

template <class T>
inline void sort3(T &x, T &y, T &z)
{  if (x > y)
   {  if (x > z)
      {  if (y > z) swap(x, z);   // 3 2 1
         else swap3(x, y, z);     // 3 1 2
      }  else swap(x, y);         // 2 1 3
   }  else
   if (x > z) swap3(x, z, y);     // 2 3 1
   else
   if (y > z) swap(y, z);         // 1 3 2
   // else do nothing             // 1 2 3
}

template <class T>
void QuickSort(T *a, int n)
{  int i, j, nleft, nright;
   T x;
   while (n >= 3)
   {  j = n - 1; i = j/2;
      sort3(a[0], a[i], a[j]);
      if (n == 3) return;
      x = a[i];
      i = 1; j--;
      do
      {  while (a[i] < x) i++;
         while (a[j] > x) j--;
         if (i < j) swap(a[i], a[j]); else
         {  if (i == j){i++; j--;}
            break;
         }
      }  while (++i <= --j);
      nleft = j + 1; 
      nright = n - i;
      if (nleft < nright)
      {  if (j > 0) 
            QuickSort(a, nleft);
         a += i; 
         n = nright;
      }  else
      {  if (nright > 1) 
            QuickSort(a + i, nright);
         n = nleft;
      }
   }
   if (n == 2 && a[0] > a[1]) 
      swap(a[0], a[1]);
}
