// select: For a given array with n elements, find the element
//         that would be at position k if the array were sorted.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 3 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>

template <class T>
T select(T *a, int n, int k)  // k < n
// Select element belonging in position k (0 <= k < n)
{  while (n > 1)
   {  // Partition:
      int i = 0, j = n - 1;
      T x = a[j/2], w;
      do
      {  while (a[i] < x) i++;
         while (a[j] > x) j--;
         if (i < j){w = a[i]; a[i] = a[j]; a[j] = w;} else
         {  if (i == j) i++;
            break;
         }
      }  while (++i <= --j);
      // Partitions: a[0],...,a[i-1] <= x, a[i],...,a[n-1] >= x
      if (k < i) n = i; else {a += i; n -= i; k -= i;}
   }
   return a[0];
}

int main()
{  int k;
   const int n = 10;
   int a[n] = {60, 60, 10, 20, 30, 10, 30, 50, 20, 40};
   cout << "Initial array contents:\n";
   for (int j=0; j<n; j++) cout << a[j] << " ";
   do
   {  cout << "\nEnter k (nonnegative and less than " << n
           << ")\n";
      cout << "to select the value that would be at\n";
      cout << "position k if the array were sorted: ";
      cin >> k;
   }  while (k < 0 || k >= n);
   cout << "Selected value: " << select(a, n, k) << endl;
   return 0;
}

