// sort2: Sorting lists of two objects.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 3 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include <string.h>

template <class T>
void swap(T &x, T &y)
{  T w = x; x = y; y = w;
}

template <class T>
void sort2(T &x, T &y)
{  if (x > y) swap(x, y);
}

class record {
public:
   char name[30];
   int number;
   record(const char *s, int i): number(i)
   {  strcpy(name, s);
   }
   int operator>(record &s){return number > s.number;}
   friend ostream &operator<<(ostream &os, record &r)
   {  return os << r.name << " " << r.number;
   }
};

class point {
public:
   float x, y;
   point(float xx, float yy): x(xx), y(yy){}
   int operator>(const point &Q) const
   {  return x * x + y * y > Q.x * Q.x + Q.y * Q.y;
   }
   friend ostream &operator<<(ostream &os, point &P)
   {  return os << P.x << " " << P.y;
   }
};

int main()
{  record R("John", 1234), S("Mary", 987);
   point P(2, 0), Q(1, 1);
   int a[3] = {6, 3, 7};
   sort2(R, S);
   sort2(P, Q);
   sort2(a[0], a[1]); 
   sort2(a[1], a[2]); 
   sort2(a[0], a[1]);
   cout << "P: " << P << "    Q: " << Q << endl;
   cout << "R: " << R << "    S: " << S << endl;
   cout << "a: ";
   for (int i=0; i<3; i++) cout << a[i] << " ";
   cout << endl;
   return 0;
}
