// cirlist: Circular linked list.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include <stdlib.h>

struct elem{int info; elem *next;};

class cirlist {
public:
   cirlist() {pStart = NULL;}
   cirlist(const cirlist& s)
   {  cout << "Copying not allowed.\n"; exit(1);
   }
   cirlist &operator=(const cirlist &s)
   {  cout << "Assignment not allowed.\n"; exit(1);
      return *this;
   }
   ~cirlist();
   void iteratorStart(elem *p=NULL)
   {  pCur = (p ? p : (pStart ? pStart->next : NULL));
   }
   elem *iterator();
   void PrintList();
   void insert(int x)  // Add at the beginning of the list
   {  elem *p = new elem;
      p->info = x;
      if (pStart) p->next = pStart->next; else pStart = p;
      pStart->next = p;
   }
   void append(int x)  // Add at the end of the list
   {  insert(x); pStart = pStart->next;
   }
private:
   elem *pStart, *pCur;
};
cirlist::~cirlist()
{  elem *p;
   iteratorStart();
   for (;;)
   {  p = iterator();
      if (p) delete p; else break;
   }
}

elem *cirlist::iterator()
{  if (pCur == NULL) return NULL;
   elem *p = pCur;
   pCur = (pCur == pStart ? NULL : pCur->next);
   return p;
}

void cirlist::PrintList()
{  elem *p;
   iteratorStart();
   while ((p = iterator()) != NULL)
      cout << p->info << " ";
   cout << endl;
}

int main()
{  cirlist L;
   cout << "Contents: "; L.PrintList();
   L.append(10);
   cout << "Contents: "; L.PrintList();
   L.append(20); L.append(30);
   L.insert(8); L.insert(5);
   cout << "Contents: "; L.PrintList();
   return 0;
}
