// linklist: Demonstration of linked-list operations.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>

struct elem{int num; struct elem *next;};

class LinkedList {
public:
   LinkedList(){pStart = pEnd = NULL;}
   ~LinkedList();
   void append(int i)
   {  pCur = pEnd;
      pEnd = new elem;
      pEnd->num = i;
      pEnd->next = NULL;
      (pCur ? pCur->next : pStart) = pEnd;
   }
   void iteratorStart(elem *p=NULL){pCur = (p ? p : pStart);}
   elem *iterator()
   {  elem *p = pCur;
      if (pCur) pCur = pCur->next;
      return p;
   }
   elem *find(int i);
   void PrintList();
private:
   elem *pStart, *pEnd, *pCur;
};

LinkedList::~LinkedList()
{  while (pStart)
   {  pCur = pStart; pStart = pStart->next; delete pCur;
   }
}
elem *LinkedList::find(int i)
{  elem *p;
   iteratorStart();
   while ((p = iterator()) != NULL)
      if (p->num == i) return p;
   return NULL;
}

void LinkedList::PrintList()
{  elem *p;
   iteratorStart();
   while ((p = iterator()) != NULL)
      cout << p->num << " ";
   cout << endl;
}

int main()
{  int i;
   LinkedList L;
   elem *p;
   for (i=10; i<18; i++) L.append(i);
   L.PrintList();
   cout << "Enter item to be searched for: ";
   cin >> i;
   p = L.find(i);
   if (p)
   {  cout << "Found. This item and those that follow "
              "are increased by 50:\n";
      L.iteratorStart(p);
      while ((p = L.iterator()) != NULL) p->num += 50;
      L.PrintList();
   }  else cout << "Not found.\n";
   return 0;
}
