// linklist.h: Template for a linked list that can be copied.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.


#include <stdlib.h>

template <class T>
struct elem{T info; elem *next;};

template <class T>
class LinkList {
public:
   LinkList() {pStart = pEnd = NULL;}
   LinkList(const LinkList<T> &s)
   {  CopyList(s);
   }
   LinkList<T> &operator=(const LinkList &s)
   {  if (&s != this)
      {  DelList();
         CopyList(s);
      }
      return *this;
   }
   virtual ~LinkList(){DelList();}
   void append(T x)
   {  pCur = pEnd;
      pEnd = new elem<T>;
      pEnd->info = x;
      pEnd->next = NULL;
      (pCur ? pCur->next : pStart) = pEnd;
   }
   void iteratorStart(elem<T> *p=NULL){pCur = (p ? p : pStart);}
   elem<T> *iterator()
   {  elem<T> *p = pCur;
      if (pCur) pCur = pCur->next;
      return p;
   }
   void PrintList();
protected:
   elem<T> *pStart, *pEnd, *pCur;
   void DelList();
   void CopyList(const LinkList<T> &s);
};

template<class T>
void LinkList<T>::DelList()
{  elem<T> *p;
   while (pStart){p = pStart; pStart = pStart->next; delete p;}
}
template <class T>
void LinkList<T>::CopyList(const LinkList<T> &s)
{  elem<T> *p = s.pStart, *pEnd0;
   pEnd = pStart = new elem<T>;
   for (;;)
   {  *pEnd = *p;
      p = p->next;
      if (p == NULL) break;
      pEnd0 = pEnd;
      pEnd = new elem<T>;
      pEnd0->next = pEnd;
   }
}

template <class T>
void LinkList<T>::PrintList()
{  elem<T> *p;
   iteratorStart();
   while ((p = iterator()) != NULL)
      cout << p->info << " ";
   cout << endl;
}
