// listap1: Class fList derived from LinkList template
//          of Section 4.5.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include "linklist.h"

typedef elem<float> Elem;
typedef LinkList<float> fLinkList;

class fList: public fLinkList {
public:
   Elem *find(float x);
   void InsertAfter(Elem *p, float x);
   void RemoveAfter(Elem *p);
};

Elem *fList::find(float x)
{  Elem *p;
   iteratorStart();
   while ((p = iterator()) != NULL)
      if (p->info == x) return p;
   return NULL;
}

void fList::InsertAfter(Elem *p, float x)
{  Elem *q = new Elem;
   q->info = x; q->next = p->next;
   p->next = q;
}

void fList::RemoveAfter(Elem *p)
{  Elem *q = p->next;
   if (q == NULL) return;
   p->next = q->next;
   delete q;
}
int main()
{  fList L, *pL[2];
   Elem *p;
   L.append(1.1); L.append(3.3); L.append(5.5);
   pL[0] = new fList;
   pL[1] = new fList;
   *pL[0] = *pL[1] = L;
   p = pL[0]->find(3.3);
   if (p) pL[0]->InsertAfter(p, 4.4);
   p = pL[1]->find(1.1);
   if (p) pL[1]->RemoveAfter(p);
   cout << "L:      "; L.PrintList();
   cout << "*pL[0]: "; pL[0]->PrintList();
   cout << "*pL[1]: "; pL[1]->PrintList();
   delete pL[0];
   delete pL[1];
   return 0;
}
