// listapp: Application of the LinkList template,
//          demonstrating list copying and assigning.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include "linklist.h"

template <class T>
LinkList<T> increase(LinkList<T> L) // Invokes copy constructor.
{  elem<T> *p;
   L.iteratorStart();
   while ((p = L.iterator()) != NULL)
      p->info += 100;             // Does not affect argument.
   return L;                      // Invokes copy constructor.
}

int main()
{  LinkList<int> l1, l2, l3;
   l1.append(111);
   l1.append(222);
   l2 = l1;
   l2.append(333);
   l3 = increase(l2);
   cout << "l1: "; l1.PrintList();
   cout << "l2: "; l2.PrintList();
   cout << "l3: "; l3.PrintList();
   return 0;
}
