// qapp: Application of queue class.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include "queue1.h"

int main()
{  queue1<int, 10> q;
   int i, x;
   try
   {  for (i=0; i<7; i++) q.AddToRear(10 * i);
      q.GetFromFront(x); cout << x << " ";  //  0
      q.GetFromFront(x); cout << x << " ";  // 10
      q.GetFromFront(x); cout << x << endl; // 20
      for (i=8; i<13; i++) q.AddToRear(10 * i);
      while (q.GetFromFront(x))
         cout << x << " "; // 30 40 50 60 70 80 90 100 110 120
      cout << endl;
      for (i=0; i<1000; i++) q.AddToRear(i);
         // Only 0, 1, ..., 9 stored, then queue overflow. 
   }
   catch(int)
   {  while (q.GetFromFront(x)) ; // Find latest element
      cout << "Queue overflow; latest element stored: "
           << x << endl;   // 9
   }
   return 0;
}

