// qsort_it: Quicksort, iterative version.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include "stack.h"

template <class T>
struct cmnd
{  float *start;
   int len;
   cmnd(float *st=NULL, int n=0)
   {  start = st; len = n;
   }
};

template <class T>
void qsort_it(T *a, int n)
{  stack<cmnd<T> > stk;
   cmnd<T> x;
   stk.push(cmnd<T>(a, n));
   while (stk.pop(x))
   {  a = x.start; n = x.len;
      int i = 0, j = n - 1;
      T x = a[j/2], w;
      do
      {  while (a[i] < x) i++;
         while (a[j] > x) j--;
         if (i < j) {w = a[i]; a[i] = a[j]; a[j] = w;} else
         {  if (i == j){i++; j--;}
            break;
         }
      }  while (++i <= --j);
      if (j > 0) stk.push(cmnd<T>(a, j+1));
      if (i < n-1) stk.push(cmnd<T>(a+i, n-i));
   }
}

int main()
{  float a[] = {19.5, 13, 10, 20.3, 7};
   int n = sizeof(a)/sizeof(*a);
   qsort_it(a, n);
   for (int i=0; i<n; i++) cout << a[i] << " ";
   cout << endl;
   return 0;
}
