// queue.h: Template for a linked queue.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <stdlib.h>
template <class T>
struct elem{T data; elem *next;};

template <class T>
class queue {
public:
   queue() {pRear = NULL;} // pRear = NULL means 'empty queue'
   ~queue();
   void AddToRear(const T &x)
   {  elem<T> *p = new elem<T>;
      (pRear ? pRear->next : pFront) = p;
      p->data = x;
      pRear = p;
   }
   int GetFromFront(T &x)
   {  elem<T> *p;
      if (pRear == NULL) return 0;
      p = pFront;
      x = p->data;
      if (p == pRear) pRear = NULL; else pFront = p->next;
      delete p;
      return 1;
   }
private:
   elem<T> *pFront, *pRear;
};

template <class T>
queue<T>::~queue()
{  T x;
   while (GetFromFront(x)) ;
}
