// rec2itr: From recursion to iteration.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include "stack.h"

struct cmnd
{  char code; // 'f' = function, 'p' = print command
   int val;   // e.g. code = 'f' and val = 4 means f(4)
   cmnd(){}
   cmnd(char c, int v){ code = c; val = v;}
};

void f(int n)
{  cmnd x;
   stack<cmnd> stk;
   stk.push(cmnd('f', n));
   while (stk.pop(x))
   {  if (x.code == 'f')
      {  if (x.val > 0)
         {  stk.push(cmnd('p', x.val));
            stk.push(cmnd('f', x.val - 1));
         }
      }  else cout << x.val << " ";
   }
}

int main(void)
{  f(4);
   cout << endl;
   return 0;
}

