// rec2ival: From recursion to iteration; value returned.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include "stack.h"

struct cmnd
{  char code;
   int val;
   cmnd(){}
   cmnd(char c, int v=0)
   {  code = c; 
      val = v;
   }
};
int fun1(int n)
{  stack<cmnd> cstk; // command stack
   stack<int> vstk;  // value stack
   cmnd x;
   int a, b;
   cstk.push(cmnd('f', n));
   
   while (cstk.pop(x))
   {  switch (x.code) {
      case 'f':
         a = x.val;
         if (a < 0) vstk.push(0); else
         {  cstk.push('s');   // subtract
            cstk.push('d');   // double
            cstk.push(cmnd('f', a - 2));
            cstk.push('t');   // triple and add 1
            cstk.push(cmnd('f', a - 1));
         }
         break;
      case 'd':
         vstk.pop(a); 
         vstk.push(2 * a);
         break;
      case 't':
         vstk.pop(a); 
         vstk.push(1 + 3 * a);
         break;
      case 's':
         vstk.pop(a);
         vstk.pop(b);
         vstk.push(b - a);
         break;
      }
   }
   
   vstk.pop(a);
   return a;
}

int main(void)
{  cout << fun1(4);
   cout << endl;
   return 0;
}

