// stack.h: Template for a linked stack.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <stdlib.h>
template <class T>
struct elem{T data; elem *next;};

template <class T>
class stack {
public:
   stack() {start = NULL;}
   ~stack();
   void push(const T &x)
   {  elem<T> *p = start;
      start = new elem<T>;
      start->data = x; start->next = p;
   }
   int pop(T &x)
   {  elem<T> *p;
      if (start)
      {  x = start->data;
         p = start;
         start = start->next;
         delete p;
         return 1;
      }  else return 0;
   }
private:
   elem<T> *start;
};

template <class T>
stack<T>::~stack()
{  elem<T> *p;
   while (start){p = start; start = start->next; delete p;}
}

