// hash1.h: Hashing based on linked lists (chaining).

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 5 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include <stdlib.h>

struct elem{char *name; unsigned num; elem *next;};

class list {
public:
   list(): pStart(NULL){}
   ~list();
   void RemoveNode(const char *s);
   void ListInsert(const char *s, unsigned num);
   elem *FindPosition(const char *s)const;
   void remove(elem *p);

   list(const list& s)
   {  cout << "Copying not allowed.\n"; exit(1);
   }

   list &operator=(const list &s)
   {  cout << "Assignment not allowed.\n"; exit(1);
      return *this;
   }
private:
   elem *pStart;
};

class StringHash {
public:
   StringHash(unsigned len=1021): N(len){a = new list[len];}
   ~StringHash(){delete[] a;}
   void insert(const char *s, unsigned num)
   {  a[hash(s)].ListInsert(s, num);
   }
   elem *find(const char *s)const
   {  return a[hash(s)].FindPosition(s);
   }
   void remove(const char *s)
   {  a[hash(s)].RemoveNode(s);
   }
   unsigned hash(const char *s)const;
private:
   unsigned N;
   list *a;
};

