// hash2.cpp: Implementation file for open hashing.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 5 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include "hash2.h"

HashTable::HashTable(unsigned len)
{  N = (len > 3 ? len : 3); // N >= 3 (see incrhash)
   a = new elem[N];
   for (unsigned i=0; i<N; i++) a[i].name[0] = '\0';
}

int HashTable::h2(const char *t, unsigned &i)const
{  unsigned count=0, incr;
   if (strcmp(a[i].name, t))
   {  incr = HashIncr();
      do
      {  if (++count == N) return 0; // Failure
         i = (i + incr) % N;
      }  while (strcmp(a[i].name, t));
   }
   return 1;  // Success
}

void HashTable::insert(const char *s, unsigned num)
{  unsigned i = hash(s);
   if (!h2("", i)){cout << "Hash table full\n"; exit(1);}
   strcpy(a[i].name, s);
   a[i].num = num;
}

elem *HashTable::find(const char *s)
{  unsigned i = hash(s);
   return h2(s, i) ? a + i : NULL;
}

unsigned HashTable::hash(const char *s)
{  sum = 0;
   for (unsigned i=0; s[i]; i++) sum += (i + 1) * s[i];
   return sum % N;
}
