// hash2ap: Hashing with open addressing
//    (application, to be linked with hash2.cpp).

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 5 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <fstream.h>
#include <iomanip.h>
#include <stdlib.h>
#include "hash2.h"

int main()
{  ifstream PhoneFile("phone.txt", ios::in);
   if (!PhoneFile)
   {  cout << "Cannot open file phone.txt.\n";
      exit(1);
   }
   char NameBuf[30];
   unsigned num, N;
   cout << "Table length N (preferably a prime number): ";
   cin >> N;
   elem *p = NULL;
   HashTable PhoneBook(N);
   cout << "Data read from file phone.txt:\n\n";
   while (PhoneFile >> setw(30) >> NameBuf >> num)
   {  cout << setw(30) << setiosflags(ios::left)
           << NameBuf << num << endl;
      PhoneBook.insert(NameBuf, num);
   }
   cout << endl;
   for (;;)
   {  cout << "Enter a name, or ! to quit: ";
      cin >> NameBuf;
      if (*NameBuf == '!') break;
      p = PhoneBook.find(NameBuf);
      if (p)
         cout << "Number: " << p->num << endl;
      else cout << "Not found." << endl;
   }
   return 0;
}

