// searchap: Searching a textfile for a string
//           (to be linked with search.cpp).

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 5 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <fstream.h>
#include <stdlib.h>
#include <string.h>
#include "search.h"

int main(int argc, char *argv[])
{  if (argc != 3)
   {  cout << "Use file name and pattern as program "
         "arguments.\n"; exit(1);
   }
   ifstream input(argv[1], ios::in);
   if (!input)
   {   cout << "Cannot open file " << argv[1] << endl; exit(1);
   }
   // Find required string length:
   int n=0, i;
   char ch;
   while (input.get(ch), !input.fail()) n++;
   input.clear(); input.seekg(0);
   char *text = new char[n + 1], *p = text, *pattern = argv[2];
   // Read text array from file:
   for (i=0; i<n; i++) input.get(text[i]);
   text[n] = '\0';
   // Specify pattern:
   search x(pattern);
   // Find all occurrences of pattern in text:
   cout << "Text from found pattern to end of line:\n";
   while ((p = x.find(p)) != 0)
   {  for (i=0; p[i] != '\0' && p[i] != '\n'; i++) cout << p[i];
      cout << endl;
      p++;
   }
   return 0;
}

