// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 6 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

// pbbtree: Building and displaying a perfectly balanced
//          binary tree
#include <iostream.h>
#include <iomanip.h>

struct node {int info; node *pLeft, *pRight;};

class pbbtree {
public:
   pbbtree(int n);
   void print()const{pr(root, 0);}
private:
   node *root;
   void pr(const node *p, int nSpace)const;
};

pbbtree::pbbtree(int n)
{  if (n == 0) root = NULL; else
   {  int nLeft = (n - 1)/2, nRight = n - nLeft - 1;
      root = new node;
      root->pLeft = pbbtree(nLeft).root;
      cin >> root->info;
      root->pRight = pbbtree(nRight).root;
   }
}

void pbbtree::pr(const node *p, int nSpace)const
{  if (p)
   {  pr(p->pRight, nSpace += 6);
      cout << setw(nSpace) << p->info << endl;
      pr(p->pLeft, nSpace);
   }
}

int main()
{  cout <<
      "Enter n, followed by n integers in ascending order:\n";
   int n;
   cin >> n;
   pbbtree t(n);
   cout << "\nHere is the resulting perfectly balanced\n"
      "binary search tree, with its root on the left.\n"
      "To obtain the usual form, with the root at the top,\n"
      "turn this output 90 degrees clockwise:\n\n";
   t.print();
   return 0;
}

