// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 8 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

// huffman.h
#include <fstream.h>
#include <string.h>
#include <iomanip.h>
#include <stdlib.h>
#define nil (-1)
typedef unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned long ulong;

void GetStreams(ifstream &ifile, ofstream &ofile);

inline void error(const char *s)
{  cout << "Error: " << s << endl; exit(1);
}

struct node {int left, RightOrCh;};

class HuffmanTree {
public:
   HuffmanTree(const ulong *freq);
   ~HuffmanTree(){delete[]A;}
   int NewNode(int left, int x)
   {  A[n].left = left; A[n++].RightOrCh = x;
      return n - 1;
   }
   node *A;
   int n, root;
};

