// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 8 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

// priorq.h: Template for priority queue
#define nil (-1)

template <class T>
class PrQ {
public:
   PrQ(int size, int increment=10)
   {  N = size;
      a = new T[N];
      n = 0; ChunkSize = increment;
   }
   ~PrQ(){delete[]a;}
   void insert(T x);
   T remove();
   int empty(){return n == 0;}
protected:
   T *a;
   int N, n, ChunkSize;
   int parent(int i){return (i-1)/2;}
   int left(int i){return 2 * i + 1;}
   int right(int i){return 2 * i + 2;}
   void sift0();
};

template <class T>
void PrQ<T>::insert(T x)
{  int i, j;
   if (n == N)
   {  T *aOld = a;
      a = new T[N += ChunkSize];
      for (i=0; i<n; i++) a[i] = aOld[i];
      delete[] aOld;
   }
   i = n++;
   while (i > 0 && x > a[j = parent(i)])
   {  a[i] = a[j]; i = j;
   }
   a[i] = x;
}

template <class T>
T PrQ<T>::remove()
{  T x = a[0];
   a[0] = a[--n];
   sift0();
   return x;
}

template <class T>
void PrQ<T>::sift0()
{  int i = 0, j;
   T x;
   x = a[0];
   while ((j = 2 * i + 1) < n)
   {  if (j < n - 1 && a[j+1] > a[j]) j++;
      if (a[j] > x){a[i] = a[j]; i = j;} else break;
   }
   a[i] = x;
}

