// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 8 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

// prqchar: A priority queue for characters
#include <iostream.h>
#include <iomanip.h>
#include <string.h>

#include "priorq.h"

class CharPrQ: public PrQ<char> {
public:
   CharPrQ(int size, int increment): PrQ<char>(size, increment){}
   void display();
};

void CharPrQ::display()
{  int i;
   cout << "     i  ->:";
   for (i=0; i<n; i++) cout << setw(3) << i;
   cout << endl;
   cout << "   a[i] ->:";
   for (i=0; i<n; i++) cout << setw(3) << a[i];
   cout << endl;
}

int main()
{  CharPrQ Q(10, 5); // Initial N = 10, ChunkSize = 5
   char ch;
   cout << "A priority queue implemented as a heap.\n";
   cout << "Enter letters to insert, - to remove, or "
           "/ to quit.\n";
   for (;;)
   {  cout << "\nEnter a letter or a command (- or /): ";
      cin >> ch;
      if (ch == '/') break;
      if (ch == '-')
      {  if (Q.empty())
            cout << "Cannot remove from empty queue.\n";
         else ch = Q.remove(); // ch not used here
      }  else Q.insert(ch);
      Q.display();
   }
   return 0;
}
