// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 9 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

// strings.cpp: See header file strings.h
#include "strings.h"

typedef char *charptr;

strings::~strings()
{  for (int i=0; i<n; i++) delete[](p[i]);
   delete[]p;
}

int strings::add(const char *s)
{  int i;
   for (i=0; i<n; i++)
      if (strcmp(p[i], s) == 0) return i;
   if (n == N)
   {  // Re-allocate:
      char **pOld = p;
      p = new charptr[N += ChunkSize];
      for (i=0; i<n; i++) p[i] = pOld[i];
      delete[]pOld;
   }
   p[n] = new char[strlen(s) + 1];
   strcpy(p[n++], s);
   return n - 1;
}

int strings::read(istream &f)
{  char buf[100];
   f >> setw(100) >> buf;
   return f.fail() ? -1 : add(buf);
}

