// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 9 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

// strings.h: Strings stored and represented
//            by ints 0, 1, 2, ...
#include <fstream.h>
#include <iomanip.h>
#include <string.h>
#include <stdlib.h>

class strings {
public:
   strings(){p = NULL; N = n = 0;}
   ~strings();
   int add(const char *s);
   char *operator[](int i)const{return p[i];}
   int read(istream &f);
   int size()const{return n;}
private:
   enum {ChunkSize = 64};
   char **p;
   int n, N;
};

