// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 10 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

/* knapsack:
     This program solves the (simplified) knapsack problem:
     given a sum s and a set of positive integers, it finds
     a subset whose elements have sum s, if this is possible.
*/
#include <iostream.h>

class knapsack {
public:
   knapsack();
   ~knapsack(){delete[]d;}
   void solve();
private:
   int s, *d, n;
   int ExactSum(int t, int i);
};

knapsack::knapsack()
{  cout << "Knapsack problem; enter the desired sum: ";
   cin >> s;
   cout << "Enter n, followed by n integers:\n";
   cin >> n;
   d = new int[n];
   for (int i=0; i<n; i++) cin >> d[i];
}

void knapsack::solve()
{  cout << "Output:\n";
   if (ExactSum(s, 0)) cout << "(sum = " << s << ")\n";
   else cout << "No solution.\n";
}

int knapsack::ExactSum(int t, int i)
{  // Is t equal to the sum of some elements
   // of the sequence d[i], d[i+1], ..., d[n-1]?
   // If so, display these elements and return 1.
   // Otherwise, return 0.
   if (t < 0) return 0;         // No solution
   if (t == 0) return 1;        // Trivial solution
   // For each available d[j], check if it can be
   // part of the solution:
   for (int j=i; j<n; j++)
      if (ExactSum(t - d[j], j+1))
      {  cout << d[j] << " "; return 1;
      }
   return 0;
}

int main()
{  knapsack K;
   K.solve();
   return 0;
}

