// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 10 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

// nested: A variable number of nested loops
#include <iostream.h>
#include <iomanip.h>

class loops {
public:
   void setup();
   void print();
private:
   int *lower, *upper, *r, n;
   void fIterative();
   void PrintArray();
};

void loops::setup()
{  cout << "Enter n: "; cin >> n;
   lower = new int[n]; upper = new int[n]; r = new int[n];
   cout << "Enter " << n << " pairs (lower, upper):\n";
   for (int i=0; i<n; i++) cin >> lower[i] >> upper[i];
}

void loops::print()
{  cout << "Output:\n\n ";
   for (int i=0; i<n; i++) cout << "  r[" << i << "]";
   cout << endl;
   fIterative();
}

void loops::fIterative()
{  int i, n1 = n - 1;
   for (i=0; i<n; i++)
      if (lower[i] > upper[i]) return;
      else r[i] = lower[i];
   for (;;)
   {  PrintArray();
      i = n1;
      for (;;)
      {  if (r[i] < upper[i])
         {  r[i]++; break;
         }
         r[i] = lower[i];
         if (--i < 0) return;
      }
   }
}

void loops::PrintArray()
{  for (int i=0; i<n; i++) cout << setw(6) << r[i];
   cout << endl;
}

int main()
{  loops L;
   L.setup();
   L.print();
   return 0;
}

