// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 10 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

// nextcomb: Find the next combination
#include <iostream.h>

class comb {
public:
   comb();
   ~comb(){delete[]r;}
   void demo();
private:
   int *r, n, k;
   int NextComb(void);
};

comb::comb()
{  cout << "Iterative combination generator for k elements\n"
        << "out of 1, 2, ..., n.\n";
   do
   {  cout << "Enter n and k (k not greater than n): ";
      cin >> n >> k;
   }  while (n < 0 || k < 0 || k > n);
   r = new int[k + 1];
   for (int i=1; i<=k; i++) r[i] = i;
}

void comb::demo()
{  int code, i, j=0;
   do
   {  cout << "\nEnter 1 to display the next combination "
           << "or 0 to stop: ";
      cin >> code;
      if (code == 0) return;
      cout << "Combination " << ++j << ": ";
      for (i=1; i<=k; i++) cout << r[i] << " ";
      cout << endl;
   }  while (NextComb());
}

int comb::NextComb()
{  // If another combination can be generated, this is
   // placed in r[1], ..., r[k] and the value 1 is returned.
   // Otherwise, the return value is 0.
   int i = k, j;
   // Find the greatest i for which r[i] can be increased:
   while (i > 0 && r[i] == n - k + i) i--;
   if (i == 0) return 0;  // No new combination
   // Increase r[i] and reset r[i+1], ..., r[k] to their
   // lowest possible values (with r in ascending order).
   r[i]++;
   for (j=i+1; j<=k; j++) r[j] = r[j-1] + 1;
   return 1;
}

int main()
{  comb P;
   P.demo();
   return 0;
}

