/* Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
   This program text occurs in Chapter 11 of

      Ammeraal, L. (1996) Algorithms and Data Structures in C++,
         Chichester: John Wiley.
*/

/* rts.c: A run-time system for VSL; after compilation, this 
          module is to be linked with object.c or with another
          file generated by the 'compiler' program.
*/

#include <stdio.h>
#include <stdlib.h>

#define STACKSIZE 20
int t, s[STACKSIZE]; /*  Initially, t = 0  */

void error(char *str)
{  printf("\n\nError: %s\n", str); exit(1);
}

void push(int i)
{  if (t == STACKSIZE)
   error(
   "STACKSIZE too small for this postfix expression"); 
   s[t++] = i;
}

void add(void)
{  t--; s[t-1] += s[t];
}

void subtract(void)
{  t--; s[t-1] -= s[t];
}

void multiply(void)
{  t--; s[t-1] *= s[t];
}

void PrintResult(void)
{  if (t != 1) error("Incorrect object program");
   printf("Result: %d\n", s[0]);
}

