//LIBRERIA PER TIPO DI DATO ASTRATTO LISTA
typedef struct cella * lista;
typedef struct cella * posizione;
typedef int tipoelem;

//PROTOTIPI
lista crealista();
int listavuota();
void inslinsta(tipoelem a, posizione *P);
lista primolista(lista L);
lista ultimolista(lista L);
posizione succlista(posizione P);
posizione predlista(posizione P);
int finelista(posizione P, lista L);
tipoelem leggilista(posizione P);
void scrivilista(tipoelem a, posizione P);
void canclista(posizione * P);

//STRUTTURA ASTRATTA
struct cella{
	lista precedente;
	tipoelem valore;
	lista successivo;
	};

//OPERATORI
lista crealista() {
	lista L ;
	L = (lista)malloc (sizeof (struct cella));
	L->successivo = L;
	L->precedente = L;
	return L;
	}

int listavuota(lista L) {
	tipoelem flag;
	flag = (((L->successivo == L) && (L->precedente == L)) ? 1 : 0);
	return flag;
	}

void inslista(tipoelem a, posizione * P) {
	posizione temp;
	temp = (lista)malloc (sizeof (struct cella));

	temp->valore = a;
	temp->precedente = (* P)->precedente;
	temp->successivo = (* P);

	((* P)->precedente)->successivo = temp;
	(*P)->precedente = temp;
	(*P) = temp;
	}

lista primolista(lista L) {
	return L->successivo;
	}

lista ultimolista(lista L) {
	return L->precedente;
	}

posizione succlista(posizione P) {
	return P->successivo;
	}

posizione predlista(posizione P) {
	return P->precedente ;
	}

int finelista(posizione P, lista L) {
	return ((P==L) ? 1 : 0);
	}

tipoelem leggilista(posizione P) {
	return P->valore;
	}

void scrivilista(tipoelem a, posizione P) {
	P->valore = a;
	}

void canclista(posizione * P) {
	posizione temp;
	temp = *P;
	
	((*P)->precedente)->successivo = (*P)->successivo;

	((*P)->successivo)->precedente = (*P)->precedente;
	
	*P = (*P)->successivo;
	free (temp);
	}

